#ifndef AY8910_H_INCLUDED
#define AY8910_H_INCLUDED

#include "pc6001v.h"
#include "device.h"
#include "ini.h"
#include "joystick.h"
#include "sound.h"

#include "p6device.h"


////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class cAY8910 : public SndDev {
protected:
	int RegisterLatch;
	BYTE Regs[16];
	int UpdateStep;
	int PeriodA, PeriodB, PeriodC, PeriodN, PeriodE;
	int CountA, CountB, CountC, CountN, CountE;
	int VolA, VolB, VolC, VolE;
	BYTE EnvelopeA, EnvelopeB, EnvelopeC;
	BYTE OutputA, OutputB, OutputC, OutputN;
	signed char CountEnv;
	BYTE Hold,Alternate,Attack,Holding;
	int RNG;
	int VolTable[32];
	
	void _AYWriteReg( BYTE, BYTE );		// 쥸ߥ
	void AYWriteReg( BYTE, BYTE );		// 쥸
	BYTE AYReadReg( BYTE );				// 쥸ɹ
	
	void SetClock( int, int );			// PSGå
	
	// ݡȥؿ
	virtual BYTE PortAread();
	virtual BYTE PortBread();
	virtual void PortAwrite( BYTE );
	virtual void PortBwrite( BYTE );
	
	virtual int GetUpdateSamples();		// ץ
	
public:
	cAY8910();							// 󥹥ȥ饯
	virtual ~cAY8910();					// ǥȥ饯
	
	void Reset( void );					// ꥻå
	
	void SetVolume( int );				// (ܥ塼ơ֥)
	int SoundUpdate( int );				// ȥ꡼๹
};


class PSG6 : public P6DEVENT, public Device, public cAY8910, public cJoy, public IDoko {
private:
	// ݡȥؿ
	BYTE PortAread();
	BYTE PortBread();
	
	int GetUpdateSamples();				// ץ
	
	// ǥХ
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/Oؿ
	inline void OutA0H( int, BYTE );	// PSG쥸ɥ쥹å
	inline void OutA1H( int, BYTE );	// PSG饤ȥǡ
	inline void OutA3H( int, BYTE );	// PSG󥢥ƥ
	inline BYTE InA2H( int );			// PSG꡼ɥǡ
	
public:
	PSG6( VM6 *, const ID& );			// 󥹥ȥ饯
	~PSG6();							// ǥȥ饯
	
	void EventCallback( int, int );		// ٥ȥХåؿ
	
	BOOL Init();						// 
	
	// ǥХID
	enum IDOut{ outA0H=0, outA1H, outA3H };
	enum IDIn {  inA2H=0 };
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};


#endif	// AY8910_H_INCLUDED
