#include "intr.h"
#include "pd8049.h"
#include "pd8255.h"
#include "schedule.h"


// ٥ID
#define	EID_TIMER	(1)


////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
INT6::INT6( VM6 *vm, const P6ID& id ) : P6DEVENT(vm,id){}
INT60::INT60( VM6 *vm, const ID& id ) : INT6(vm,id), Device(id){}
INT62::INT62( VM6 *vm, const ID& id ) : INT6(vm,id), Device(id){}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
INT6::~INT6( void ){}
INT60::~INT60( void ){}
INT62::~INT62( void ){}


////////////////////////////////////////////////////////////////
// ٥ȥХåؿ
////////////////////////////////////////////////////////////////
void INT6::EventCallback( int id, int clock )
{
	switch( id ){
	case EID_TIMER:		// ޳ȯ
		PRINTD( INTR_LOG, "[INTR][EventCallback] TimerIntr\n" );
		
		#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		if( vm->cGlobal::TimerIntr )
		#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
			ReqIntr( IREQ_TIMER );
		break;
	}
}


////////////////////////////////////////////////////////////////
// ޳߼ȿѹ
////////////////////////////////////////////////////////////////
void INT6::SetTimerIntrHz( BYTE data )
{
	TimerCntUp = data;
	vm->sche->SetHz( this, EID_TIMER, UTIMER_HZ/(TimerCntUp+1) );
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL INT6::Init( void )
{
	PRINTD( INTR_LOG, "[INTR][Init]\n" );
	
	// ٥ɲ
	if( !vm->sche->Add( this, EID_TIMER, DEFAULT_TIMER_HZ, EV_LOOP|EV_HZ ) ) return FALSE;
	
	Reset();
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ꥻå
////////////////////////////////////////////////////////////////
void INT60::Reset( void )
{
	PRINTD( INTR_LOG, "[INTR][Reset]\n" );
	
	// ߥɥ쥹
	TimerAddr = 6;
	
	// Ƽѿ
	TimerCntUp       = 3;
	TimerIntrEnable  = FALSE;	// ޳ߵĥե饰ߤ
	IntrFlag         = 0;		// ׵ե饰ꥢ
	
	// ޳߼ȿ
	SetTimerIntrHz(	TimerCntUp );
}

void INT62::Reset( void )
{
	PRINTD( INTR_LOG, "[INTR][Reset]\n" );
	
	// ߥɥ쥹
	TimerAddr  = 6;
	Int1Addr   = 0;
	Int2Addr   = 0;
	
	// Ƽѿ
	TimerCntUp       = 3;
	TimerIntrEnable  = FALSE;	// ޳ߵĥե饰ߤ
	TimerIntrEnable2 = FALSE;	// ޳ߵĥե饰ߤ(mk2ʹ)
	Int1IntrEnable   = TRUE;	// INT1ߵĥե饰ΩƤ
	Int2IntrEnable   = FALSE;	// INT2ߵĥե饰ߤ
	Int1AddrOutput   = FALSE;	// INT1ߥɥ쥹ϥե饰ߤ
	Int2AddrOutput   = FALSE;	// INT2ߥɥ쥹ϥե饰ߤ
	IntrFlag         = 0;		// ׵ե饰ꥢ
	
	// ޳߼ȿ
	SetTimerIntrHz(	TimerCntUp );
}


////////////////////////////////////////////////////////////////
// ߥå
//   ȯϥޤ8049,ͥ褫?
////////////////////////////////////////////////////////////////
int INT6::IntrCheck( void )
{
	int	IntrNo = -1;
	
	// ޳
	if( ( IntrFlag & IREQ_TIMER ) && IsTimerIntrEnable() ){
		PRINTD( INTR_LOG, "[INTR][IntrCheck](Timer)\n" );
		
		CancelIntr( IREQ_TIMER );
		IntrNo    = TimerAddr>>1;
	}
	// 8049
	else if( IntrFlag & IREQ_8049 ){
		PRINTD( INTR_LOG, "[INTR][IntrCheck](8049)\n" );
		
		CancelIntr( IREQ_8049 );
		IntrNo = vm->pio->ReadA() / 2;
	}
	
	if( IntrNo >= 0 ){
		PRINTD1( INTR_LOG, " IntrNo = %d\n", IntrNo  );
		IntrNo <<= 1;
	}
	
	return IntrNo;
}


////////////////////////////////////////////////////////////////
// ׵
////////////////////////////////////////////////////////////////
void INT6::ReqIntr( DWORD vec )
{
	IntrFlag |= vec;
	
	PRINTD2( INTR_LOG, "[INTR][ReqIntr] %04X -> %04X\n", vec, IntrFlag );
}


////////////////////////////////////////////////////////////////
// ű
////////////////////////////////////////////////////////////////
void INT6::CancelIntr( DWORD vec )
{
	IntrFlag &= ~vec;
	
	PRINTD2( INTR_LOG, "[INTR][CancelIntr] %04X -> %04X\n", vec, IntrFlag );
}


////////////////////////////////////////////////////////////////
// ޳ߵĥå
////////////////////////////////////////////////////////////////
BOOL INT62::IsTimerIntrEnable( void )
{
	return TimerIntrEnable && TimerIntrEnable2;
}


////////////////////////////////////////////////////////////////
// ߵĥե饰
////////////////////////////////////////////////////////////////
void INT62::SetIntrEnable( BYTE data )
{
	Int1IntrEnable   = (data&0x01 ? FALSE : TRUE);
	Int2IntrEnable   = (data&0x02 ? FALSE : TRUE);
	TimerIntrEnable2 = (data&0x04 ? FALSE : TRUE);
	Int1AddrOutput   = (data&0x08 ? FALSE : TRUE);
	Int2AddrOutput   = (data&0x10 ? FALSE : TRUE);
}


////////////////////////////////////////////////////////////////
// ɤǤSAVE
////////////////////////////////////////////////////////////////
BOOL INT6::DokoSave( cIni *Ini )
{
	cSche::evinfo e;
	char stren[16];
	
	e.device = this;
	
	if( !Ini ) return FALSE;
	
	Ini->PutEntry( "INTR", NULL, "IntrFlag",			"0x%08X",	IntrFlag );
	Ini->PutEntry( "INTR", NULL, "TimerIntrEnable",		"%s",		TimerIntrEnable ? "Yes" : "No" );
	Ini->PutEntry( "INTR", NULL, "TimerAddr",			"0x%02X",	TimerAddr );
	
	// ٥
	e.id = EID_TIMER;
	if( vm->sche->GetEvinfo( &e ) ){
		sprintf( stren, "Event%08X", e.id );
		Ini->PutEntry( "INTR", NULL, stren, "%d %d %d %lf", e.Active ? 1 : 0, e.Period, e.Clock, e.nps );
	}
	
	return TRUE;
}

BOOL INT62::DokoSave( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	Ini->PutEntry( "INTR", NULL, "TimerIntrEnable2",	"%s",		TimerIntrEnable2 ? "Yes" : "No" );
	Ini->PutEntry( "INTR", NULL, "Int1Addr",			"0x%02X",	Int1Addr );
	Ini->PutEntry( "INTR", NULL, "Int2Addr",			"0x%02X",	Int2Addr );
	
	return INT6::DokoSave( Ini );
}



////////////////////////////////////////////////////////////////
// ɤǤLOAD
////////////////////////////////////////////////////////////////
BOOL INT6::DokoLoad( cIni *Ini )
{
	int st,yn;
	cSche::evinfo e;
	char stren[16];
	char strrs[64];
	
	e.device = this;
	
	if( !Ini ) return FALSE;
	
	Ini->GetInt(   "INTR", "IntrFlag",			&st,				IntrFlag );	IntrFlag = st;
	Ini->GetTruth( "INTR", "TimerIntrEnable",	&TimerIntrEnable,	TimerIntrEnable );
	Ini->GetInt(   "INTR", "TimerAddr",			&st,				TimerAddr );	TimerAddr = st;
	
	// ٥
	e.id = EID_TIMER;
	sprintf( stren, "Event%08X", e.id );
	if( Ini->GetString( "INTR", stren, strrs, "" ) ){
		sscanf( strrs,"%d %d %d %lf", &yn, &e.Period, &e.Clock, &e.nps );
		e.Active = yn ? TRUE : FALSE;
		if( !vm->sche->SetEvinfo( &e ) ) return FALSE;
	}
	
	return TRUE;
}

BOOL INT62::DokoLoad( cIni *Ini )
{
	int st;
	
	if( !Ini ) return FALSE;
	
	Ini->GetTruth( "INTR", "TimerIntrEnable2",	&TimerIntrEnable2,	TimerIntrEnable2 );
	Ini->GetInt(   "INTR", "Int1Addr",			&st,				Int1Addr );		Int1Addr = st;
	Ini->GetInt(   "INTR", "Int2Addr",			&st,				Int2Addr );		Int2Addr = st;
	
	return INT6::DokoLoad( Ini );
}


////////////////////////////////////////////////////////////////
//  device description
////////////////////////////////////////////////////////////////
const Device::Descriptor INT60::descriptor = {
	INT60::indef, INT60::outdef
};

const Device::OutFuncPtr INT60::outdef[] = {
	STATIC_CAST( Device::OutFuncPtr, &INT60::OutB0H )
};

const Device::InFuncPtr INT60::indef[] = {
};


const Device::Descriptor INT62::descriptor = {
	INT62::indef, INT62::outdef
};

const Device::OutFuncPtr INT62::outdef[] = {
	STATIC_CAST( Device::OutFuncPtr, &INT62::OutB0H ),
	STATIC_CAST( Device::OutFuncPtr, &INT62::OutF3H ),
	STATIC_CAST( Device::OutFuncPtr, &INT62::OutF4H ),
	STATIC_CAST( Device::OutFuncPtr, &INT62::OutF5H ),
	STATIC_CAST( Device::OutFuncPtr, &INT62::OutF6H ),
	STATIC_CAST( Device::OutFuncPtr, &INT62::OutF7H )
};

const Device::InFuncPtr INT62::indef[] = {
	STATIC_CAST( Device::InFuncPtr, &INT62::InF3H ),
	STATIC_CAST( Device::InFuncPtr, &INT62::InF4H ),
	STATIC_CAST( Device::InFuncPtr, &INT62::InF5H ),
	STATIC_CAST( Device::InFuncPtr, &INT62::InF6H ),
	STATIC_CAST( Device::InFuncPtr, &INT62::InF7H )
};
