#ifndef INTR_H_INCLUDED
#define INTR_H_INCLUDED

#include "pc6001v.h"
#include "device.h"
#include "ini.h"

#include "p6device.h"

// ׵ե饰
//  0 RS232S  
//  1 3
//  2 ͽ
//  3 ޳
//  4 CMT READ 
//  5 ͽ
//  6 ͽ
//  7 1 1
//  8 1 2
//  9 CMT ERROR 
// 10 2
// 11 ѥ
// 12 8049(嵭1-11)
#define	IREQ_SIO	(0x0001)
#define	IREQ_KEY3	(0x0002)
#define	IREQ_TIMER	(0x0008)
#define	IREQ_CMT_R	(0x0010)
#define	IREQ_KEY1	(0x0080)
#define	IREQ_KEY1_2	(0x0100)
#define	IREQ_CMT_E	(0x0200)
#define	IREQ_KEY2	(0x0400)
#define	IREQ_JOY	(0x0800)
#define	IREQ_8049	(0x1000)

// ߥ٥
#define	IVEC_NOINTR	(0xff)
#define	IVEC_SIO	(0)
#define	IVEC_KEY3	(2)
#define	IVEC_TIMER	(6)
#define	IVEC_CMT_R	(8)
#define	IVEC_KEY1	(14)
#define	IVEC_KEY12	(16)
#define	IVEC_CMT_E	(18)
#define	IVEC_KEY2	(20)
#define	IVEC_JOY	(22)


////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class INT6 : public P6DEVENT, public IDoko {
protected:
	DWORD IntrFlag;			// ׵ե饰
	
	BOOL TimerIntrEnable;	// ޳ߵĥե饰
	BYTE TimerAddr;			// ޳ߥɥ쥹
	BYTE TimerCntUp;		// ޳ߥȥå
	
	void SetTimerIntrHz( BYTE );			// ޳߼ȿѹ
	virtual BOOL IsTimerIntrEnable() = 0;	// ޳ߵĥå
	
public:
	INT6( VM6 *, const P6ID& );				// 󥹥ȥ饯
	virtual ~INT6();						// ǥȥ饯
	
	void EventCallback( int, int );			// ٥ȥХåؿ
	
	BOOL Init();							// 
	virtual void Reset() = 0;				// ꥻå
	
	int	IntrCheck();						// ߥå
	
	void ReqIntr( DWORD );					// ׵
	void CancelIntr( DWORD );				// ű
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};


class INT60 : public INT6, public Device {
private:
	BOOL IsTimerIntrEnable(){ return TimerIntrEnable; }	// ޳ߵĥå
	
	// ǥХ
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/Oؿ
	inline void OutB0H( int , BYTE data ){ PRINTD1( INTR_LOG, "[INTR][OutB0H] %02X\n", data );
										     TimerIntrEnable = (data&1 ? FALSE : TRUE); }
	
public:
	INT60( VM6 *, const ID& );				// 󥹥ȥ饯
	~INT60();								// ǥȥ饯
	
	void Reset();							// ꥻå
	
	// ǥХID
	enum IDOut{ outB0H=0 };
	enum IDIn {};
};


class INT62 : public INT6, public Device {
private:
	BOOL TimerIntrEnable2;	// ޳ߵĥե饰(PortF3H mk2ʹ)
	BOOL Int1IntrEnable;	// INT1ߵĥե饰
	BOOL Int2IntrEnable;	// INT2ߵĥե饰
	BOOL Int1AddrOutput;	// INT1ߥɥ쥹ϥե饰
	BOOL Int2AddrOutput;	// INT2ߥɥ쥹ϥե饰
	
	BYTE Int1Addr;			// INT1ߥɥ쥹
	BYTE Int2Addr;			// INT2ߥɥ쥹
	
	BOOL IsTimerIntrEnable();				// ޳ߵĥå
	void SetIntrEnable( BYTE );				// ߵĥե饰
	
	// ǥХ
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/Oؿ
	inline void OutB0H( int, BYTE data ){ PRINTD1( INTR_LOG, "[INTR][OutB0H] %02X\n", data );
										  TimerIntrEnable  = (data&1 ? FALSE : TRUE); }
	inline void OutF3H( int, BYTE data ){ PRINTD1( INTR_LOG, "[INTR][OutF3H] %02X\n", data );
										  SetIntrEnable( data ); }
	inline void OutF4H( int, BYTE data ){ PRINTD1( INTR_LOG, "[INTR][OutF4H] %02X\n", data );
										  Int1Addr = data; }
	inline void OutF5H( int, BYTE data ){ PRINTD1( INTR_LOG, "[INTR][OutF5H] %02X\n", data );
										  Int2Addr = data; }
	inline void OutF6H( int, BYTE data ){ PRINTD1( INTR_LOG, "[INTR][OutF6H] %02X\n", data );
										  SetTimerIntrHz( data ); }
	inline void OutF7H( int, BYTE data ){ PRINTD1( INTR_LOG, "[INTR][OutF7H] %02X\n", data );
										  TimerAddr = data; }
	inline BYTE InF3H( int ){ return (Int1IntrEnable   ? 0 : 0x01) | (Int2IntrEnable ? 0 : 0x02) |
									 (TimerIntrEnable2 ? 0 : 0x04) | (Int1AddrOutput ? 0 : 0x08) |
									 (Int2AddrOutput   ? 0 : 0x10) | 0xe0; }
	inline BYTE InF4H( int ){ return Int1Addr; }
	inline BYTE InF5H( int ){ return Int2Addr; }
	inline BYTE InF6H( int ){ return TimerCntUp; }
	inline BYTE InF7H( int ){ PRINTD1( INTR_LOG, "[INTR][InF7H] %02X\n", TimerAddr );
							  return TimerAddr; }
	
public:
	INT62( VM6 *, const ID& );				// 󥹥ȥ饯
	~INT62();								// ǥȥ饯
	
	void Reset();							// ꥻå
	
	// ǥХID
	enum IDOut{ outB0H=0, outF3H, outF4H, outF5H, outF6H, outF7H };
	enum IDIn {  inF3H=0,  inF4H,  inF5H,  inF6H,  inF7H };
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};

#endif	// INTR_H_INCLUDED
