#ifndef PC60_H_INCLUDED
#define PC60_H_INCLUDED

#include "pc6001v.h"
#include "global.h"
#include "SThread.h"
#include "movie.h"


#define	FRAMERATE	(VSYNC_HZ/(cGlobal::FrameSkip+1))


class CPU6;
class SUB6;
class IO6;
class MEM6;
class VDG6;
class DSP6;
class INT6;
class KEY6;
class DSK6;
class CMTL;
class CMTS;
class SND6;
class PSG6;
class PIO6;
class SCH6;
class VCE6;
class cWndStat;

#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
class BPoint;
class cWndReg;
class cWndMem;
class cWndMon;
#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //


////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
// ܲۥޥ󥯥饹
class VM6 : virtual public cGlobal, public SThread, public AVI6 {
	
	// vm->xxx ȤˤfriendǤʤʤ󡣤äȥ䡣
	friend class VDG6;
	friend class VDG60;
	friend class VDG62;
	friend class DSP6;
	friend class SUB6;
	friend class PIO6;
	friend class CPU6;
	friend class PSG6;
	friend class INT6;
	friend class VCE6;
	friend class CMTL;
	friend class DSK6;
	friend class DSK60;
	friend class DSK66;
	friend class SCH6;
	friend class KEY6;
	friend class cWndStat;
	
	#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	friend class cWndReg;
	friend class cWndMem;
	friend class cWndMon;
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
protected:
	// ֥ȥݥ
	IO6 *io;					// I/O(Z80)
	IO6 *ios;					// I/O(SUB CPU)
	INT6 *intr;					// 
	SCH6 *sche;					// 塼
	SND6 *snd;					// 
	CPU6 *cpu;					// CPU
	SUB6 *subcpu;				// SUB CPU
	MEM6 *mem;					// 
	VDG6 *vdg;					// VDG
	DSP6 *graph;				// 
	PSG6 *psg;					// PSG
	VCE6 *voice;				// 
	PIO6 *pio;					// 8255
	KEY6 *key;					// 
	CMTL *cmt;					// CMT
	CMTS *cmts;					// CMT(SAVE)
	DSK6 *disk;					// DISK
	cWndStat *staw;				// ơС
	
	#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	BPoint *bp;					// ֥졼ݥ
	cWndReg *regw;				// 쥸ɥ
	cWndMem *memw;				// ꥦɥ
	cWndMon *monw;				// ˥ɥ
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	SDL_TimerID UpDateFPSID;	// FPSɽID
	
	BOOL ScreenUpdate();								// ̹
	int SoundUpdate( int, cRing * = NULL );				// ɹ
	static void StreamUpdate( void *, Uint8 *, int);	// ȥ꡼๹ Хåؿ
	static Uint32 UpDateFPS( Uint32, void * );			// FPSɽ Хåؿ
	BOOL SetFPSTimer( int );							// FPSɽ
	
	int UDFPSCount;				// FPSɽޥ
	int FSkipCount;				// ե졼ॹåץ
	
	void OnThread( void * );				// åɴؿ
	BOOL IsWaitEnable();					// Waitͭ?
	
	BOOL CheckFuncKey( SDL_Event * );		// Ƽﵡǽå
	
	// ꥢؿ
	BYTE Fetch( WORD, int * = NULL );		// եå(M1)
	BYTE Read( WORD, int * = NULL );		// ꡼
	void Write( WORD, BYTE, int * = NULL );	// 饤
	
	// I/Oؿ
	BYTE In( int );							// INؿ
	void Out( int, BYTE );					// OUTؿ
	
public:
	VM6();									// 󥹥ȥ饯
	virtual ~VM6();							// ǥȥ饯
	
	virtual BOOL Init() = 0;				// 
	BOOL InitCommon();						// ʬ
	
	BOOL Start();							// ư
	void Stop();							// ư
	void Reset();							// ꥻå
	
	int Emu();								// 1̿¹
	int EmuVSYNC();							// 1ʬ¹
	
	#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	void Exec( int );						// ꥹơȿ¹
//	void ExecBP( int );						// ꥹơȿ¹(֥졼ݥȤ)
	BOOL ToggleMonitor();					// ˥⡼ؤ
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	BOOL AutoType( char * );				// Auto Type
	BOOL TapeInsert( char * );				// TAPE 
	void TapeEject();						// TAPE ӽ
	BOOL DiskInsert( int, char * );			// DISK 
	void DiskEject( int );					// DISK ӽ
	BOOL ExtRomInsert( char * );			// ĥROM 
	void ExtRomEject();						// ĥROM ӽ
	
	BOOL EventLoop();						// ٥ȥ롼
	
	void ShowPopupMenu( int, int );			// ݥåץåץ˥塼ɽ
	
	// ------------------------------------------
	BOOL DokoDemoSave( char * );	// ɤǤSAVE
	BOOL DokoDemoLoad( char * );	// ɤǤLOAD
	// ------------------------------------------
};

// PC-6001 ۥޥ󥯥饹
class VM60 : public VM6 {
public:
	VM60();			// 󥹥ȥ饯
	~VM60();		// ǥȥ饯
	
	BOOL Init();	// 
};

// PC-6001mk2 ۥޥ󥯥饹
class VM62 : public VM6 {
public:
	VM62();			// 󥹥ȥ饯
	~VM62();		// ǥȥ饯
	
	BOOL Init();	// 
};

// PC-6601 ۥޥ󥯥饹
class VM66 : public VM6 {
public:
	VM66();			// 󥹥ȥ饯
	~VM66();		// ǥȥ饯
	
	BOOL Init();	// 
};

#endif		// PC60_H_INCLUDED
