#include <string.h>

#include "voice.h"
#include "schedule.h"


// ٥ID
#define	EID_FRAME	(1)



////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
VCE6::VCE6( VM6 *vm, const ID& id ) : P6DEVENT(vm,id), Device(id)
{
	SndDev::Volume = DEFAULT_VOICEVOL;
	*FilePath = '\0';
	io_E0H = io_E2H = io_E3H = 0;
	Pnum    = 0;
	Fnum    = 0;
	PReady 	= FALSE;
	Fbuf    = NULL;
	VStat   = D7752E_IDL;
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
VCE6::~VCE6()
{
	if( Fbuf )    delete [] Fbuf;
}


////////////////////////////////////////////////////////////////
// ٥ȥХåؿ
//
// :	id		٥ID
//			clock	å
// :	ʤ
////////////////////////////////////////////////////////////////
void VCE6::EventCallback( int id, int clock )
{
	PRINTD( VOI_LOG, "[VOICE][EventCallback] -> " );
	
	switch( id ){
	case EID_FRAME:	// 1ե졼
		if( VStat & D7752E_EXT ){	// ȯ
			PRINTD( VOI_LOG, "(EXT)\n" );
			if( PReady ){	// ѥ᡼åȴλƤ?
				// ե졼=0ʤнλ
				if( !(ParaBuf[0]>>3) )
					AbortVoice();
				else{
					// 1ե졼ʬΥץ
					PD7752::Synth(	ParaBuf, Fbuf );
					
					// ץ󥰥졼ȤѴƥХåե˽
					UpConvert();
					
					// ե졼Υѥ᡼դ
					PReady = FALSE;
					VStat |= D7752E_REQ;
				}
			}else{			// λƤʤХ顼
				AbortVoice();		// ȯ
				VStat = D7752E_ERR;	// ơ򥨥顼ȯ˥å
			}
		}else{						// ȯ
			PRINTD( VOI_LOG, "(INT) " );
			// 1ե졼ʬΥץХåե˽
			int num = min( IVLen - IVPos, PD7752::GetFrameSize() * vm->snd->GetSampleRate() / 10000 );
			PRINTD2( VOI_LOG, "%d/%d\n", num, IVPos );
			while( num-- )
				SndDev::cRing::Put( ( IVBuf[IVPos++] * SndDev::Volume ) / 100 );
			if( IVPos >= IVLen ){	// Ǹޤȯȯλ
				AbortVoice();
			}
		}
		
		break;
	}
}


////////////////////////////////////////////////////////////////
// ⡼ɥå
////////////////////////////////////////////////////////////////
void VCE6::VSetMode( BYTE mode )
{
	PRINTD2( VOI_LOG, "[VOICE][VSetMode]    %02X %dms", mode, (((mode>>2)&1)+1)*10 );
	PRINTD1( VOI_LOG, " %s\n", mode&1 && mode&2 ? "X" : mode&1 ? "SLOW" : mode&2 ? "FAST" : "NORMAL" );
	
	// 
	PD7752::Start( mode );
	
	// ơꥢ
	VStat = D7752E_IDL;
}


////////////////////////////////////////////////////////////////
// ޥɥå
////////////////////////////////////////////////////////////////
void VCE6::VSetCommand( BYTE comm )
{
	PRINTD1( VOI_LOG, "[VOICE][VSetCommand] %02X\n", comm );
	
	// ȯʤߤ
	AbortVoice();
	
	switch( comm ){
	case 0x00:		// 򥳥ޥ ----------
	case 0x01:
	case 0x02:
	case 0x03:
	case 0x04:
		// WAVեɹ
		if( !LoadVoice( comm ) ) break;
		
		// ơ⡼ɤ˥å
		VStat = D7752E_BSY;
		
		// ե졼।٥Ȥ򥻥åȤ
		vm->sche->Add( this, EID_FRAME, 10000.0/(double)PD7752::GetFrameSize(), EV_LOOP|EV_HZ );
		
		break;
		
	case 0xfe:		// 򥳥ޥ ----------
		// ե졼Хåե
		Fbuf = new D7752_SAMPLE[PD7752::GetFrameSize()];
		if( !Fbuf ) break;
		
		// ơ⡼ɤ˥åȡѥ᡼ճ
		VStat = D7752E_BSY | D7752E_EXT | D7752E_REQ;
		
		// ե졼।٥Ȥ򥻥åȤ
		vm->sche->Add( this, EID_FRAME, 10000.0/(double)PD7752::GetFrameSize(), EV_LOOP|EV_HZ );
		
		break;
		
	case 0xff:		// ȥåץޥ ----------
		break;
		
	default:		// ̵ޥ  ----------
		VStat = D7752E_ERR;	// ۥ?
		break;
	}
}


////////////////////////////////////////////////////////////////
// ѥ᡼ž
////////////////////////////////////////////////////////////////
void VCE6::VSetData( BYTE data )
{
	PRINTD1( VOI_LOG, "[VOICE][VSetData]    %02X\n", data );
	
	// Τߥǡդ
	if(	(VStat & D7752E_BSY)&&(VStat & D7752E_REQ) ){
		if( Fnum == 0 || Pnum ){	// ǽΥե졼?
			// ǽΥѥ᡼ä鷫֤
			if( Pnum == 0 ) Fnum = data>>3;
			// ѥ᡼Хåե¸
			ParaBuf[Pnum++] = data;
			// ⤷1ե졼ʬΥѥ᡼ίޤäȯλ
			if( Pnum == 7 ){
				VStat &= ~D7752E_REQ;
				Pnum = 0;
				if( Fnum > 0 ) Fnum--;
				PReady = TRUE;
			}
		}else{						// ֤ե졼?
			// ѥ᡼Хåե¸
			// PD7752λͤ˹碌
			for( int i=1; i<6; i++ ) ParaBuf[i] = 0;
			ParaBuf[6] = data;
			VStat &= ~D7752E_REQ;
			Pnum = 0;
			Fnum--;
			PReady = TRUE;
		}
	}
}


////////////////////////////////////////////////////////////////
// ơ쥸
////////////////////////////////////////////////////////////////
int VCE6::VGetStatus( void )
{
	return VStat;
}


////////////////////////////////////////////////////////////////
// ȯ
////////////////////////////////////////////////////////////////
void VCE6::AbortVoice( void )
{
	PRINTD( VOI_LOG, "[VOICE][AbortVoice]\n" );
	
	// ե졼।٥
	vm->sche->Del( this, EID_FRAME );
	
	// ĤΥѥ᡼ϥ󥻥
	Pnum = Fnum = 0;
	PReady = FALSE;
	
	// ե졼Хåե
	if( Fbuf ){
		delete [] Fbuf;
		Fbuf = NULL;
	}
	
	// WAV
	FreeVoice();
	
	VStat &= ~D7752E_BSY;
}


////////////////////////////////////////////////////////////////
// ץ󥰥졼Ѵ
////////////////////////////////////////////////////////////////
void VCE6::UpConvert( void )
{
	PRINTD( VOI_LOG, "[VOICE][UpConvert]\n" );
	
	// 10kHz -> ºݤ˺륵ץ󥰥졼ȤѴΥץ
	int samples = PD7752::GetFrameSize() * vm->snd->GetSampleRate() / 10000;
	PRINTD1( VOI_LOG, "UpConvert %d \n", samples );
	
	for( int i=0; i<samples; i++ ){
		int dat = Fbuf[i * PD7752::GetFrameSize() / samples] * 4;	// * 4  16bit<-14bit Τ
//		SndDev::cRing::Put( ( dat * SndDev::Volume ) / 100 );
		SndDev::cRing::Put( ( dat * SndDev::Volume * 2 ) / 100 );		// ϥ٥뤬㤤ΤǤȤꤢ2
	}
	PRINTD( VOI_LOG, "\n" );
}


////////////////////////////////////////////////////////////////
// WAVɹ
////////////////////////////////////////////////////////////////
BOOL VCE6::LoadVoice( int index )
{
	PRINTD1( VOI_LOG, "[VOICE][LoadVoice]  No.%d -> ", index );
	
	SDL_AudioSpec ws;
	Uint32 len;		// ǡ
	Uint8 *buf;	// ǡХåե
	
	// WAVեɹ
	char filepath[MAX_PATH];
	sprintf( filepath, "%sf4%d.wav", FilePath, index );
	
	PRINTD1( VOI_LOG, "%s ->", filepath );
	
	if( !SDL_LoadWAV( filepath, &ws, &buf, &len ) ){
		PRINTD( VOI_LOG, "Error!\n" );
		return FALSE;
	}
	
	// 22050Hzʾ,16bit,1ch Ǥʤä
	if( ws.freq < 22050 || ws.format != AUDIO_S16 || ws.channels != 1 ){
		PRINTD3( VOI_LOG, "F:%d S:%d C:%d -> Error!\n", ws.freq, ws.format, ws.channels );
		SDL_FreeWAV( buf );
		return FALSE;
	}
	PRINTD( VOI_LOG, "OK\n" );
	
	// ȯ®ѴΥ׻ƥХåե
	// ȯ®4λ,1ե졼Υץ160
	IVLen = (int)( (double)vm->snd->GetSampleRate() * (double)(len/2) / (double)ws.freq
					* (double)PD7752::GetFrameSize() / (double)160 );
	
	PRINTD2( VOI_LOG, "Len:%d/%d ->", IVLen, len );
	
	IVBuf = new int[IVLen];
	if( !IVBuf ){
		SDL_FreeWAV( buf );
		IVLen = 0;
		return FALSE;
	}
	
	// ȯ®Ѵ
	// ñʤְʤΤǥԥåѤäƤޤΤ
	// FFTȤ?
	Sint16 *sbuf = (Sint16 *)buf;
	for( int i=0; i<IVLen; i++ ){
		IVBuf[i] = sbuf[(int)(( (double)i * (double)(len/2) ) / (double)IVLen)];
	}
	
	// WAV
	SDL_FreeWAV( buf );
	
	// ɹߥݥ󥿽
	IVPos = 0;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// WAV
////////////////////////////////////////////////////////////////
void VCE6::FreeVoice( void )
{
	if( IVBuf ){
		delete [] IVBuf;
		IVBuf = NULL;
		IVLen = IVPos= 0;
	}
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL VCE6::Init( char *path )
{
	PRINTD( VOI_LOG, "[VOICE][Init] BufferSize:" );
	
	// ȥ꡼³
	vm->snd->ConnectStream( (cRing *)this );
	
	// WAVEեǼѥ¸
	strncpy( FilePath, path, MAX_PATH );
	
	PRINTD1( VOI_LOG, ":%d\n", SndDev::cRing::GetSize() );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ꥻå
////////////////////////////////////////////////////////////////
void VCE6::Reset( void )
{
	AbortVoice();
	VStat = D7752E_IDL;
}


////////////////////////////////////////////////////////////////
// ȥ꡼๹
////////////////////////////////////////////////////////////////
int VCE6::SoundUpdate( int samples )
{
	PRINTD( VOI_LOG, "[VOICE][Update]\n" );
	
	return 0;
}


////////////////////////////////////////////////////////////////
// ɤǤSAVE
//
// :	Ini		INI֥ȥݥ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL VCE6::DokoSave( cIni *Ini )
{
	cSche::evinfo e;
	char stren[16];
	
	e.device = this;
	
	if( !Ini ) return FALSE;
	
	Ini->PutEntry( "VOICE", NULL, "io_E0H",		"0x%02X",	io_E0H );
	Ini->PutEntry( "VOICE", NULL, "io_E2H",		"0x%02X",	io_E2H );
	Ini->PutEntry( "VOICE", NULL, "io_E3H",		"0x%02X",	io_E3H );
	Ini->PutEntry( "VOICE", NULL, "VStat",		"%d",		VStat );
	
	// ط
//	int IVLen;						// ץ
//	int *IVBuf;						// ǡХåե
//	int IVPos;						// ɹߥݥ
	
	Ini->PutEntry( "VOICE", NULL, "ParaBuf0",	"0x%02X",	ParaBuf[0] );
	Ini->PutEntry( "VOICE", NULL, "ParaBuf1",	"0x%02X",	ParaBuf[1] );
	Ini->PutEntry( "VOICE", NULL, "ParaBuf2",	"0x%02X",	ParaBuf[2] );
	Ini->PutEntry( "VOICE", NULL, "ParaBuf3",	"0x%02X",	ParaBuf[3] );
	Ini->PutEntry( "VOICE", NULL, "ParaBuf4",	"0x%02X",	ParaBuf[4] );
	Ini->PutEntry( "VOICE", NULL, "ParaBuf5",	"0x%02X",	ParaBuf[5] );
	Ini->PutEntry( "VOICE", NULL, "ParaBuf6",	"0x%02X",	ParaBuf[6] );
	Ini->PutEntry( "VOICE", NULL, "Pnum",		"%d",		Pnum );
	Ini->PutEntry( "VOICE", NULL, "Fnum",		"%d",		Fnum );
	Ini->PutEntry( "VOICE", NULL, "PReady",		"%s",		PReady ? "Yes" : "No" );
	
//	D7752_SAMPLE *Fbuf;				// ե졼Хåեݥ(10kHz 1ե졼)
	
	// ٥
	e.id = EID_FRAME;
	if( vm->sche->GetEvinfo( &e ) ){
		sprintf( stren, "Event%08X", e.id );
		Ini->PutEntry( "VOICE", NULL, stren, "%d %d %d %lf", e.Active ? 1 : 0, e.Period, e.Clock, e.nps );
	}
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ɤǤLOAD
//
// :	Ini		INI֥ȥݥ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL VCE6::DokoLoad( cIni *Ini )
{
	int st;
	cSche::evinfo e;
	char stren[16];
	
	e.device = this;
	
	if( !Ini ) return FALSE;
	
	Ini->GetInt(   "VOICE", "io_E0H",		&st,		io_E0H );	io_E0H = st;
	Ini->GetInt(   "VOICE", "io_E2H",		&st,		io_E2H );	io_E2H = st;
	Ini->GetInt(   "VOICE", "io_E3H",		&st,		io_E3H );	io_E3H = st;
	Ini->GetInt(   "VOICE", "VStat",		&VStat,		VStat );
	
	// ط(Ȥꤢ̵)
	FreeVoice();
	
	Ini->GetInt(   "VOICE", "ParaBuf0",		&st,		ParaBuf[0] );	ParaBuf[0] = st;
	Ini->GetInt(   "VOICE", "ParaBuf1",		&st,		ParaBuf[1] );	ParaBuf[1] = st;
	Ini->GetInt(   "VOICE", "ParaBuf2",		&st,		ParaBuf[2] );	ParaBuf[2] = st;
	Ini->GetInt(   "VOICE", "ParaBuf3",		&st,		ParaBuf[3] );	ParaBuf[3] = st;
	Ini->GetInt(   "VOICE", "ParaBuf4",		&st,		ParaBuf[4] );	ParaBuf[4] = st;
	Ini->GetInt(   "VOICE", "ParaBuf5",		&st,		ParaBuf[5] );	ParaBuf[5] = st;
	Ini->GetInt(   "VOICE", "ParaBuf6",		&st,		ParaBuf[6] );	ParaBuf[6] = st;
	Ini->GetInt(   "VOICE", "Pnum",			&Pnum,		Pnum );
	Ini->GetInt(   "VOICE", "Fnum",			&Fnum,		Fnum );
	Ini->GetTruth( "VOICE", "PReady",		&PReady,	PReady );
	
//	D7752_SAMPLE *Fbuf;				// ե졼Хåեݥ(10kHz 1ե졼)
	
	// ٥
	e.id = EID_FRAME;
	if( vm->sche->GetEvinfo( &e ) ){
		sprintf( stren, "Event%08X", e.id );
		Ini->PutEntry( "VOICE", NULL, stren, "%d %d %d %lf", e.Active ? 1 : 0, e.Period, e.Clock, e.nps );
	}
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
//  device description
////////////////////////////////////////////////////////////////
const Device::Descriptor VCE6::descriptor = {
	VCE6::indef, VCE6::outdef
};

const Device::OutFuncPtr VCE6::outdef[] = {
	STATIC_CAST( Device::OutFuncPtr, &VCE6::OutE0H ),
	STATIC_CAST( Device::OutFuncPtr, &VCE6::OutE2H ),
	STATIC_CAST( Device::OutFuncPtr, &VCE6::OutE3H )
};

const Device::InFuncPtr VCE6::indef[] = {
	STATIC_CAST( Device::InFuncPtr, &VCE6::InE0H ),
	STATIC_CAST( Device::InFuncPtr, &VCE6::InE2H ),
	STATIC_CAST( Device::InFuncPtr, &VCE6::InE3H )
};
